<script setup lang="ts">
import {type MessageInterface, useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";
import Toast, {type ToastMessageOptions} from "primevue/toast";
import {useToast} from "primevue/usetoast";
import {ref, watch} from "vue";

const snackbarStore = useSnackbarStore();
const oldMessages:  ref<Array<MessageInterface>> = ref<Array<MessageInterface>>([]);
const toast = useToast();

watch(snackbarStore.messages, (newMessages: Array<MessageInterface>) => {
  for (const newMessage of newMessages) {
    if (!newMessage.toast) {
      newMessage.toast = {
        severity: newMessage.type,
        summary: newMessage.title,
        detail: newMessage.text,
      };
      toast.add(newMessage.toast);
    }
  }

  for (const oldMessage of oldMessages.value) {
    const toastOptions = oldMessage.toast;

    if(!toastOptions){
      return;
    }

    const found = newMessages.find((newMessage: MessageInterface) => newMessage.timeout === oldMessage.timeout);

    if (!found) {
      toast.remove(toastOptions);
    }
  }

  oldMessages.value = [...newMessages];
})

</script>

<template>
  <Toast @close="(message: ToastMessageOptions) => snackbarStore.removeMessageWithToast(message)"/>
</template>